require(['config'], function() {
	require([
		
	], function($) {
			pageObj.init();
	});
});

/********************************************************
--------------------------------------------------------
- Object 목록								            -
--------------------------------------------------------
* const gridColModel = {}	: 화면 Grid Object			*
* let pageObj = {}			: 화면공통 Object			*
* let listObj = {}			: 목록화면 Object			*
*******************************************************/

/*화면 변수*/
const ORDMNG03010_GRID_ID = '#ITP_ORDMNG03010_jqGrid';
const ORDMNG03010_GRID_LIST = '#ITP_ORDMNG03010_jqGrid_list';
const ORDMNG03010_GRID_PAGER = '#ITP_ORDMNG03010_jqGridPager';
const ORDMNG03010_GRID_EMPTY = '#ITP_ORDMNG03010_jqGridEmpty';

/*API URL*/
let API_DELI_GRID_LIST 	= '/api/pomng/inoutmng/spply-deli-grid-list';// 목록
let API_INFO_INV 		= '/api/pomng/inoutmng/init-spply-inv';	// 상세

/*화면 Grid ColModel*/
const gridColModel = {
	list: [
			{
				index: 'Brand_ID', name: 'brandId',
				label: ITP_MSG_LOCALE.label.brandId, //브랜드
				width: '18', fixed: false, align: 'center',
				sortable: false, hidden: true
			},
			{
				index: 'Brand_Nm', name: 'brandNm',
				label: ITP_MSG_LOCALE.label.brandNm, //브랜드
				width: '20', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'DLV_STTMT_NO', name: 'dlvSttmtUnqNo',
				label: ITP_MSG_LOCALE.label.dlvSttmtUnqNo, //납품서번호
				width: '20', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'ITEM_ST_CD', name: 'dlvStCd',
				label: '납품상태', //납품서상태
				width: '12', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PODR_REG_DT', name: 'podrRegDt',
				label: '수주일자', //수주일자
				width: '14', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PCH_ITEM_YN', name: 'dlvReqDt',
				label: ITP_MSG_LOCALE.label.dlvReqDt, //납품요청일
				width: '14', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PCH_ITEM_YN', name: 'dlvSchDt',
				label: ITP_MSG_LOCALE.label.dlvSchDt, //납품예정일
				width: '14', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PCH_ITEM_YN', name: 'dlvCmpltDt',
				label: ITP_MSG_LOCALE.label.dlvCmpltDt, //납품완료일
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'ITEM_CLASS_NM', name: 'itemId',
				label: ITP_MSG_LOCALE.label.itemId, //품목번호
				width: '11', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PODR_PSSBLDVSN_NM', name: 'itemNm',
				label: ITP_MSG_LOCALE.label.itemNm, //품목명
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PODR_QTY', name: 'podrQty',
				label: ITP_MSG_LOCALE.label.podrQty, //수주수량
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'SALE_ITEM_YN', name: 'dlvQty',
				label: ITP_MSG_LOCALE.label.dlvQty, //납품수량
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'UNIT', name: 'unit',
				label: ITP_MSG_LOCALE.label.unit, //납품수량
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PCH_ITEM_YN', name: 'unitAmt',
				label: ITP_MSG_LOCALE.label.unitAmt, //납품금액
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'SALE_ITEM_YN', name: 'whsNm',
				label: ITP_MSG_LOCALE.label.whsNm, //납품장소
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PCH_ITEM_YN', name: 'dlvMgrNm',
				label: ITP_MSG_LOCALE.label.dlvMgrNm, //납품담당자
				width: '8', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'PCH_ITEM_YN', name: 'dlvMgrTelNo',
				label: ITP_MSG_LOCALE.label.dlvMgrTelNo, //납품담당연락처
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			}
	],
};
/*화면공통 Object*/
let pageObj = {
	init: function () {
			this.ui.init();
			this.event.init();
			this.action();
	},
	ui: {
		init: function () {
			this.view();
			listObj.init();
		},
		view: function() {
			// 버튼 권한설정
			fn_proc_btn_auth('ORDMNG03010');

		}
	},
	action: function () {
		var _this = this;
		// 검색 납품장소
		$('#ITP_FORM_ORDMNG03010_SSEARCH_SWHS_NM').on('click', function() {
			_this.popup('SW');
		});
		// 검색 납품장소 텍스트 삭제 버튼 클릭
		$('#ITP_FORM_ORDMNG03010_SDELETE_SWHS_NM').on('click', function() {
			$('#ITP_FORM_ORDMNG03010_SEARCH_SWHS_NM').val('');
			$('#ITP_FORM_ORDMNG03010_SEARCH_SWHS_ID').val('');
		});
	
	},
	popup: function () {
		var popFn ;
			popFn = this.callback.searWhs;
	  const key = {brandId:fn_make_user_info.get('brandId'),storeId:fn_make_user_info.get('storeId'), whsDvsn:""};
			fn_call_popup('biz', 'BIZPOP_WHS_LOCATION', '#ITP_ASIDE', popFn, key, 'S');
	},
	callback: {
		searWhs: function(rowDataPop) {
			if(rowDataPop) {
				$('#ITP_FORM_ORDMNG03010_SEARCH_SWHS_NM').val(rowDataPop.whsNm);
				$('#ITP_FORM_ORDMNG03010_SEARCH_SWHS_ID').val(rowDataPop.whsId);
			}
		},
	},
	event: {
		init: function () {
				this.button();
		},
		button: function () {
				// 버튼 클릭 이벤트
			$('button').each(function() {
				var id = $(this).attr('id');
				$(this).on('click', function() {
					switch (id) {
						case 'ITP_BTN_ORDMNG03010_SRH'		: listObj.button.search();		break;	// 조회 버튼 클릭
						case 'ITP_BTN_ORDMNG03010_POPUP'	: listObj.button.create(); 		break;	// 납품서출력 팝업
					}
				});
			});
		}
	},
	screen: function() {
			$('#ITP_FORM_ORDMNG03010_SEARCH_SPPLY_ID').val(fn_make_user_info.get('userId'));
			$('#ITP_FORM_ORDMNG03010_SEARCH_BRAND_ID').val(fn_make_user_info.get('brandId'));					
			$('#ITP_FORM_ORDMNG03010_SDELETE_SWHS_NM').show();
	}
};

/*목록화면 Object*/
let listObj = {
	init: function () {
			this.grid.init();
	},
	itp_ORDMNG03010_search: false,
	
	button: {
			search: function() {
					listObj.itp_ORDMNG03010_search = true;
					let param = $('#ITP_FORM_ORDMNG03010_SEARCH').serializeObject();
					param.gridSize = $.jgrid.defaults.rowNum;
					param.gridPage = $.jgrid.defaults.pageITP_FORM_ORDMNG03010_SSEARCH_SWHS_NM;
					$(ORDMNG03010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
			},
			create: function() {
					if(!fn_make_user_info.isEmpty()) {
						const rowKey = $(ORDMNG03010_GRID_ID).getGridParam('selrow');
						if (!rowKey) {//선택 안했을시
							alert("납품서를 선택해주세요 (대표 납품서번호)") ;
							return;
						}
						var selectedIds = $(ORDMNG03010_GRID_ID).getGridParam('selarrrow');
						if(selectedIds.length > 1) { // 1이상 선택
						   alert("납품서 하나만 선택해주세요 (대표 납품서번호)") ;
							return;
						} 
						var selRowData ;
						
						for (var i=selectedIds.length-1; i>=0; i--) {//1개만 선택시
							selRowData = $(ORDMNG03010_GRID_ID).jqGrid('getRowData', selectedIds[i]);
						}
						const key = {brandId :fn_make_user_info.get('brandId'), dlvSttmtUnqNo : selRowData.dlvSttmtUnqNo};
						fn_call_popup('biz', 'BIZPOP_DLV_STTMT_PRN', '#ITP_ASIDE',null, key, 'S');
					}
			}
			
	},
	empty: {
			init: function() {
				var _this = this;
				this.push();
				$(ORDMNG03010_GRID_EMPTY).on('click', function() {
						_this.itp_ORDMNG03010_param.gridSize = $.jgrid.defaults.rowNum;
						$(ORDMNG03010_GRID_ID).setGridParam({'postData': JSON.stringify(_this.itp_ORDMNG03010_param)}).trigger('reloadGrid');
				});
			},
			itp_ORDMNG03010_param: {},
			push: function() {
				let param = $('#ITP_FORM_ORDMNG03010_SEARCH').serializeObject();
				listObj.itp_ORDMNG03010_param = param;
			},
	},
	grid: {
		init: function () {
				// 데이터 없을때
			listObj.empty.push();
			this.search();
		},
		colModel: gridColModel.list,
		search: function() {
			pageObj.screen();
			this.load();
		},
		load: function() {
			let param = $('#ITP_FORM_ORDMNG03010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.sbrandId = fn_make_user_info.get('brandId');
			var option = {
				gridId: ORDMNG03010_GRID_ID,
				colModel: gridColModel.list,
				param: param,
				url: DOMAIN + API_DELI_GRID_LIST,
				pager: ORDMNG03010_GRID_PAGER,
				multiselect: true,
				loadComplete: function(data) {
					itp_fn_grid_load_complete(data, ORDMNG03010_GRID_ID, true, 'number', 'ORDMNG03010', listObj.itp_ORDMNG03010_search, listObj.empty, true, data.gridRecords, true);

					var ids = $(ORDMNG03010_GRID_ID).getDataIDs();
					$.each(ids, function(idx, rowId) {
						$(ORDMNG03010_GRID_ID).jqGrid('setCell', rowId, '', '', ITP_GRID_COL_STYLE.link);
					});
				},
				onPaging: function(action) {
					itp_fn_grid_paging(ORDMNG03010_GRID_ID, action, param);
				}
			};
			itp_fn_grid_make_remote(option);
		},
	}
};
